From a958e830a313b23c59d545ce53589addc8ef9139 Mon Sep 17 00:00:00 2001
From: Adam Samalik <asamalik@redhat.com>
Date: Oct 16 2019 18:29:29 +0000
Subject: [PATCH 26/88] reuse english sources for missing translated ones


---

diff --git a/build-scripts/build-translated.py b/build-scripts/build-translated.py
index f8678ae..44c912c 100755
--- a/build-scripts/build-translated.py
+++ b/build-scripts/build-translated.py
@@ -73,33 +73,154 @@ def generate_lang_switch_ui(languages):
 
     return "\n".join(template_list)
 
+def prepare_translated_sources(translated_sources, site_yml, languages, config):
+    with tempfile.TemporaryDirectory() as workdir:
+        # Location of the translated-sources repo
+        #   (This repo only holds content that has some translations done,
+        #   so it might be incomplete.)
+        translated_sources_original = os.path.join(workdir, "translated_sources_original")
+
+        # Location of the English sources in the same structure
+        # as translated-sources, so:
+        #    COMPONENT/VERSION/antora.yml
+        #    COMPONENT/VERSION/modules/MODULE1
+        #    COMPONENT/VERSION/modules/MODULE2
+        #    COMPONENT/VERSION/modules/...
+        en_sources = os.path.join(workdir, "en_sources")
+
+        # Clone the original translated-sources
+        subprocess.run(["git", "clone", config["translated_sources_repo_url"], translated_sources_original])
+
+        # Get a list of the original English repos
+        repos = []
+        for repo_data in site_yml["content"]["sources"]:
+
+            if "branches" not in repo_data:
+                repo_data["branches"] = ["master"]
+            if "start_path" not in repo_data:
+                repo_data["start_path"] = ""
+
+            for branch in repo_data["branches"]:
+                repo = {}
+                repo["url"] = repo_data["url"]
+                repo["branch"] = branch
+                repo["start_path"] = repo_data["start_path"]
+
+                repos.append(repo)
+        
+        # Clome the original English sources and put them into the
+        # desired structure in en_sources (described above)
+        components = {}
+        for repo in repos:
+            with tempfile.TemporaryDirectory() as tmp_repo_root:
+                log("")
+                log("Cloning {url} {branch}".format(url=repo["url"], branch=repo["branch"]))
+                subprocess.run(["git", "clone", "--branch", repo["branch"], repo["url"], tmp_repo_root])
+
+                repo_dir = os.path.join(tmp_repo_root, repo["start_path"])
+                antora_yml_file = os.path.join(repo_dir, "antora.yml")
+                with open(antora_yml_file, "r") as file:
+                    antora_yml = yaml.safe_load(file)
+
+                component = antora_yml["name"]
+                version = antora_yml["version"]
+
+                # Saving components and all their versions
+                if component not in components:
+                    components[component] = set()
+                components[component].add(version)
+
+                for module in os.listdir(os.path.join(repo_dir, "modules")):
+                    # Now this is looping over modules accross all components,
+                    # so component, module, and version variables are available
+
+                    try:
+                        os.makedirs(os.path.join(en_sources, component, version, "modules"))
+                    except OSError as e:
+                        if e.errno != errno.EEXIST:
+                            raise
+                    
+                    original_module_dir = os.path.join(repo_dir, "modules", module)
+                    module_dir = os.path.join(en_sources, component, version, "modules", module)
+
+                    subprocess.run(["cp", "-r", original_module_dir, module_dir])
+
+                    if module == "ROOT" or "nav" in antora_yml:
+                        # if this is the main antora.yml file
+                        subprocess.run(["cp", "-r", antora_yml_file, os.path.join(en_sources, component, version, "antora.yml")])
+                        log("----- copying antora.yml for  {component} {module} {version}".format(
+                                component=component, module=module, version=version))
+                    else:
+                        log("----- skipping antora.yml for  {component} {module} {version}".format(
+                                component=component, module=module, version=version))
+
+        # Set up the language structure in translated_sources
+        for language in languages:
+            lang_dir = os.path.join(translated_sources, language)
+            try:
+                os.makedirs(lang_dir)
+            except OSError as e:
+                if e.errno != errno.EEXIST:
+                    raise
+        
+        # Copy the English sources in the translated_sources
+        for language in languages:
+            lang_dir = os.path.join(translated_sources, language)
+            for component in components:
+                en_component_dir = os.path.join(en_sources, component)
+                subprocess.run(["cp", "-r", en_component_dir, lang_dir])
+
+        # And finally copy the original translated sources
+        # into translated_sources
+        for language in languages:
+            src = os.path.join(translated_sources_original, language)
+            subprocess.run(["cp", "-r", src, translated_sources + "/"])
+
+    return components
+
+
+def init_git_repo(path):
+    try:
+        os.makedirs(path)
+    except OSError as e:
+        if e.errno != errno.EEXIST:
+            raise
+    subprocess.run(["git", "init"], cwd=path)
+    subprocess.run(["git", "config", "--global", "user.name", "Your Name"], cwd=path)
+    subprocess.run(["git", "config", "--global", "user.email", "you@example.com"], cwd=path)
+    subprocess.run(["git", "commit", "--allow-empty", "-m", "init"], cwd=path)
+
 
 def main():
     config = GLOBAL_CONFIG
-
-    log("")
-    log("===== Getting a list of languages =====")
-    languages = get_languages(config)
-    log("  Languages: {}".format(" ".join(languages)))
-
-
-    log("")
-    log("===== Generating the language switch UI =====")
-    lang_switch_ui = generate_lang_switch_ui(["en-US"] + list(languages.keys()))
     
-
-    log("")
-    log("===== Getting the site definition =====")
     with tempfile.TemporaryDirectory() as workdir:
+
+        # Location of the docs-fp-o repo
         docs_repo = os.path.join(workdir, "docs_repo")
+
+        # Location of the translated sources used for the build
+        #   (That's the translated-sources repo with the missing files added
+        #   from the English sources.)
+        translated_sources = os.path.join(workdir, "translated_sources")
+        init_git_repo(translated_sources)
+
+        log("")
+        log("===== Getting the site definition (site.yml) =====")
         subprocess.run(["git", "clone", "--branch", config["docs_repo_branch"], config["docs_repo_url"], docs_repo])
 
         with open(os.path.join(docs_repo, "site.yml"), "r") as file:
             original_site_yml = yaml.safe_load(file)
 
+        log("")
+        log("===== Getting a list of languages =====")
+        languages = get_languages(config)
+        log("  Languages: {}".format(" ".join(languages)))
 
         log("")
-        log("===== Creating the language switch UI files =====")
+        log("===== Generating the language switch UI =====")
+        lang_switch_ui = generate_lang_switch_ui(["en-US"] + list(languages.keys()))
+
         ui_dir = os.path.join(docs_repo, "supplemental-ui", "partials")
         try:
             os.makedirs(ui_dir)
@@ -111,29 +232,6 @@ def main():
         with open(ui_file, "w") as file:
             file.write(lang_switch_ui)
 
-        log("")
-        log("===== Generating site.lang.yml files =====")
-        for lang, start_paths in languages.items():
-            lang_site_yml = copy.deepcopy(original_site_yml)
-
-            lang_site_yml["output"]["dir"] = "./public/{lang}".format(lang=lang)
-
-            lang_site_yml["content"] = {}
-            lang_site_yml["content"]["branches"] = "master"
-            lang_site_yml["content"]["sources"] = []
-
-            for start_path in start_paths:
-                source = {}
-                source["url"] = config["translated_sources_repo_url"]
-                source["start_path"] = start_path
-
-                lang_site_yml["content"]["sources"].append(source)
-
-            filename = os.path.join(docs_repo, "site-{lang}.yml".format(lang=lang))
-            with open(filename, "w") as file:
-                file.write(yaml.dump(lang_site_yml))
-
-            log("  {lang} done".format(lang=lang))
 
 
         # Timestamp to be included in the footer of the docs
@@ -150,7 +248,6 @@ def main():
         if result.returncode != 0:
             log("ERROR building the en-US site")
             sys.exit(1)
-
             
         log("")
         log("===== Copying the en-US site =====")
@@ -171,7 +268,41 @@ def main():
         shutil.copy(source_index_html, target_index_html)
 
 
-        # Second, building and copying all the translated sites
+        # Second, preparing the translated sources to contain all the necessary files
+        log("")
+        log("===== Preparing the translated sources =====")
+        components = prepare_translated_sources(translated_sources, original_site_yml, languages, config)
+
+
+        log("")
+        log("===== Generating site.lang.yml files =====")
+        for lang in languages:
+            lang_site_yml = copy.deepcopy(original_site_yml)
+
+            lang_site_yml["output"]["dir"] = "./public/{lang}".format(lang=lang)
+
+            lang_site_yml["content"] = {}
+            # Branches are set to HEAD because the script uses a locally-generated
+            # content on top of the original translated-sources repo
+            lang_site_yml["content"]["branches"] = "HEAD"
+            lang_site_yml["content"]["sources"] = []
+
+            for component, versions in components.items():
+                for version in versions:
+                    source = {}
+                    source["url"] = translated_sources
+                    source["start_path"] = "{lang}/{component}/{version}".format(
+                                lang=lang, component=component, version=version)
+
+                    lang_site_yml["content"]["sources"].append(source)
+
+            filename = os.path.join(docs_repo, "site-{lang}.yml".format(lang=lang))
+            with open(filename, "w") as file:
+                file.write(yaml.dump(lang_site_yml))
+
+            log("  {lang} done".format(lang=lang))
+
+        # Third, building and copying all the translated sites
         for lang in languages:
             log("")
             log("===== Building the {lang} site =====".format(lang=lang))
@@ -202,3 +333,4 @@ def main():
 
 if __name__ == "__main__":
     main()
+

